# spirix_bumpies.rb - Version 1.0 - (C) 2015 by Aqualung - Permission granted to freely use this
# code as long as this line and the preceding line are included in any derivative work(s)JRH
#
# 12/22/2015 - Initial release (JRH 1.0)
#-----------------------------------------------------------------------------
require 'sketchup.rb'
#-----------------------------------------------------------------------------
module Spirix
  module BumpyPolygons
# MAIN BODY -----------------------------------------------------------------------------
    class << self
      @@model = Sketchup.active_model
# MAIN PROCEDURE ------------------------------------------------------------------------
      def spirix_bumpy_polygons()
        model = Sketchup.active_model
        dict = model.attribute_dictionaries['Spirix_Bumpy_Parameters']
        if !dict
          dict = model.attribute_dictionary("Spirix_Bumpy_Parameters",true)
          init_dictionary_bumpies(dict)
        end
        prompts = ["X Start ","X End ","X Steps ","Y Start ","Y End ","Y Steps ","Z Maximum ","Z Minimum ","Name "]
        defaults = [dict['x_start'].to_l,dict['x_end'].to_l,dict['x_steps'],dict['y_start'].to_l,dict['y_end'].to_l,dict['y_steps'],dict['z_max'].to_l,dict['z_min'].to_l,dict['name']]
        list = ["","","","","","","","",""]
        input = UI.inputbox prompts, defaults, list, "Enter Bumpy Parameters:"
        if(input)
          xs = input[0].to_f
          xe = input[1].to_f
          xc = input[2].to_i
          ys = input[3].to_f
          ye = input[4].to_f
          yc = input[5].to_i
          ze = input[6].to_f
          zs = input[7].to_f
          gn = input[8].to_s
          dict['x_start'] = input[0].to_l
          dict['x_end'] = input[1].to_l
          dict['x_steps'] = input[2]
          dict['y_start'] = input[3].to_l
          dict['y_end'] = input[4].to_l
          dict['y_steps'] = input[5]
          dict['z_max'] = input[6].to_l
          dict['z_min'] = input[7].to_l
          dict['name'] = input[8]
          xd = (xe - xs) / xc.to_f
          yd = (ye - ys) / yc.to_f
          model.start_operation "Spirix Bumpies"
          mesh = Geom::PolygonMesh.new((xc + 1) * (yc + 1), xc * yc * 2)
          node = []
          zd = ze - zs
          for i in 0..xc do
            pts = []
            x = (xs + i * xd).to_f
            for j in 0..yc do
              y = (ys + j * yd).to_f
              z = zs + zd * rand()
              if(z > ze)
                z = ze
              end
              pts.push(Geom::Point3d.new(x,y,z))
            end
            node.push(pts)
          end
          group = model.active_entities.add_group
          for i in 0...xc do
            for j in 0...yc do
              mesh.add_polygon(node[i][j],node[i+1][j],node[i][j+1])
              mesh.add_polygon(node[i][j+1],node[i+1][j],node[i+1][j+1])
            end
          end
          group.entities.fill_from_mesh(mesh,1,0)
          group.name = gn
          model.commit_operation
        end
      end
  #-----------------------------------------------------------------------------
      def init_dictionary_bumpies(dict)
        dict['x_start'] = '-10.0"'
        dict['x_end'] = '10.0"'
        dict['x_steps'] = '10'
        dict['y_start'] = '-10.0"'
        dict['y_end'] = '10.0"'
        dict['y_steps'] = '10'
        dict['z_max'] = '1.0"'
        dict['z_min'] = '0.0"'
        dict['name'] = ""
      end
    end
#----------------------------------------------------------------------------------------
    unless file_loaded?("spirix_bumpies.rb")
      menu = UI.menu("PlugIns").add_item("Spirix Bumpies") { spirix_bumpy_polygons() }
      file_loaded("spirix_bumpies.rb")
    end
#----------------------------------------------------------------------------------------
  end
end
